package initialize

import (
	"gitea.pena/PenaSide/treasurer/internal/errors"
	svc_mock "gitea.pena/PenaSide/treasurer/internal/service/mock"
	"gitea.pena/PenaSide/treasurer/internal/worker/mock"
	"go.uber.org/zap"
)

type WorkersDeps struct {
	Logger  *zap.Logger
	Service *svc_mock.Service
}

type Workers struct {
	Mock *mock.Worker
}

func NewWorkers(deps WorkersDeps) (*Workers, errors.Error) {
	mockWorker, err := mock.New(mock.WorkerDeps{
		Logger:      deps.Logger,
		MockService: deps.Service,
	})
	if err != nil {
		return nil, err
	}

	return &Workers{
		Mock: mockWorker,
	}, nil
}
