package payment_provider

import (
	"context"
	"gitea.pena/PenaSide/treasurer/internal/errors"
	"gitea.pena/PenaSide/treasurer/internal/models"
	"github.com/gofiber/fiber/v2"
)

type PaymentProvider interface {
	GetName() string
	RegisterWebhookHandlers(router fiber.Router)
	GetSupportedPaymentMethods() []models.PaymentType
	CreateInvoice(ctx context.Context, request map[string]string) (string, errors.Error)
}
